import { window } from "./browser";
import { FIXED_DIGIT } from "./const";
export function toArray(nodes) {
    var el = [];
    for (var i = 0, len = nodes.length; i < len; i++) {
        el.push(nodes[i]);
    }
    return el;
}
export function $(param, multi) {
    if (multi === void 0) { multi = false; }
    var el;
    if (typeof param === "string") {
        var match = param.match(/^<([a-z]+)\s*([^>]*)>/);
        if (match) {
            var dummy = document.createElement("div");
            dummy.innerHTML = param;
            el = toArray(dummy.childNodes);
        }
        else {
            el = toArray(document.querySelectorAll(param));
        }
        if (!multi) {
            el = el.length >= 1 ? el[0] : undefined;
        }
    }
    else if (param === window) {
        el = param;
    }
    else if (param.nodeName &&
        (param.nodeType === 1 || param.nodeType === 9)) {
        el = param;
    }
    else if (("jQuery" in window && param instanceof jQuery) ||
        param.constructor.prototype.jquery) {
        el = multi ? param.toArray() : param.get(0);
    }
    else if (Array.isArray(param)) {
        el = param.map(function (v) { return $(v); });
        if (!multi) {
            el = el.length >= 1 ? el[0] : undefined;
        }
    }
    return el;
}
var raf = window.requestAnimationFrame || window.webkitRequestAnimationFrame;
var caf = window.cancelAnimationFrame || window.webkitCancelAnimationFrame;
if (raf && !caf) {
    var keyInfo_1 = {};
    var oldraf_1 = raf;
    raf = function (callback) {
        function wrapCallback(timestamp) {
            if (keyInfo_1[key]) {
                callback(timestamp);
            }
        }
        var key = oldraf_1(wrapCallback);
        keyInfo_1[key] = true;
        return key;
    };
    caf = function (key) {
        delete keyInfo_1[key];
    };
}
else if (!(raf && caf)) {
    raf = function (callback) {
        return window.setTimeout(function () {
            callback(window.performance && window.performance.now && window.performance.now() || new Date().getTime());
        }, 16);
    };
    caf = window.clearTimeout;
}
export function requestAnimationFrame(fp) {
    return raf(fp);
}
export function cancelAnimationFrame(key) {
    caf(key);
}
export function map(obj, callback) {
    var tranformed = {};
    for (var k in obj) {
        k && (tranformed[k] = callback(obj[k], k));
    }
    return tranformed;
}
export function filter(obj, callback) {
    var filtered = {};
    for (var k in obj) {
        k && callback(obj[k], k) && (filtered[k] = obj[k]);
    }
    return filtered;
}
export function every(obj, callback) {
    for (var k in obj) {
        if (k && !callback(obj[k], k)) {
            return false;
        }
    }
    return true;
}
export function equal(target, base) {
    return every(target, function (v, k) { return v === base[k]; });
}
export function toFixed(num) {
    return Math.round(num * FIXED_DIGIT) / FIXED_DIGIT;
}
//# sourceMappingURL=utils.js.map